/*******************************

Chumby self-test program

bunnie 5/15/2006
********************************/

#include "mx2.h"
#include "mx2_nand.h"
#include "uart.h"
#include "usb.h"


#define PROMPT "Chumby > "


void printt(char * str) {
  EUARTputString(str);
}

char blockingGetChar() {
  while (!EUARTdataReady());		// wait for key press
  return(EUARTgetData());
}

void printhelp() {
  printt( "Chumby self-test routine:\n" );
  printt( "  h            this message\n" );
}

void init() {
  int i;

  /** from here down to next note, not sure if this init is needed--scammed from 2bl **/
  //comment # Config MUX for pin PF18->CS1
  //comment # Clear PTF_GIUSE 
  //setmem 0x10015520 0x00000000 32
  _reg_GPIO_GIUS(GPIOF)&=~0x40000;
  //comment # Clear PTF_GPR
  //setmem 0x10015538 0x00000000 32
  _reg_GPIO_GPR(GPIOF)&=~0x40000;

  //comment # FMCR Register
  //comment # Select CS3/CSD0 Pin as CS3 only.
  //setmem 0x10027814 0xFFFFFFC9 32
  _reg_SYS_FMCR=0xFFFFFFC1; // changed bunnie


  // Initialize all peripheral in AIPI1 PSR[1:0] => 10=32bit, 01=16bit, 00=8bit
  _reg_AIPI1_PSR0 = 0x00040304;
  _reg_AIPI1_PSR1 = 0xFFFBFCFB;

  // Initialize all peripheral in AIPI1 PSR[1:0] => 10=32bit, 01=16bit, 00=8bit
  _reg_AIPI2_PSR0 = 0x0;
  _reg_AIPI2_PSR1 = 0xFFFFFFFF;
  
  //write to the FMCR [31:24] (CLKMODE[1:0]) in order to get the write enable signal active
  _reg_SYS_FMCR |= 0xAA000000;
  
  _reg_CRM_PCDR0=(_reg_CRM_PCDR0&0xffff0fff)|0x00007000;
  for(i=0;i<100000;i++);
  /** end of questionable scammed init code **/

  MX21_UartSetting();
  MX21_InitInternalUART();
}

void interact() {
  char cmd;

  while(1) {
    printt(PROMPT);
    
    cmd = blockingGetChar();
    
    switch(cmd) {
    case 'h':
      printhelp();
      break;
    default:
      printt("Unrecognized command.\n");
    }
  }
}

int main() {
  
  // initialize hardware needed for the test
  init();

  // do the interaction loop
  interact();
}
